part of xfxbase;

// import 'package:flutter/material.dart';
// import 'XfxMenu.dart';
// import 'package:xwidgetsbase/XStylesBase.dart';

class XApp {
  String app_Name;
  String app_Version;
  String app_FontFamily;
  Color? app_MainColor;
  String api_URL;
  String? blob_ConnString_XUpdater;
  String? blob_ConnString_ToSave;
  String? blob_nameAPP;
  List<XMenuGroup> liXMenus = List<XMenuGroup>.empty(growable: true);
  late Widget Function(XMenuItem) getWidget_FormMenuItem;

  late XAppData? appState;
  late XAppServices? appServices = XAppServices();
  late DataService? appDataService = DataService();
  late Isolate? dataSendBackThread;
  late SendPort? dataSendBackSendMsgPort;

  XApp({
    this.app_Name = "",
    this.app_Version = "",
    this.app_FontFamily = "",
    this.app_MainColor,
    this.api_URL = "",
    this.blob_ConnString_XUpdater = "",
    this.blob_ConnString_ToSave = "",
    this.blob_nameAPP = "",
    this.appState,
    this.appServices,
    this.appDataService,
    this.dataSendBackThread,
    this.dataSendBackSendMsgPort,
  }) {
    XStyles.googleFontFamily = app_FontFamily;
    if (blob_ConnString_ToSave != null && blob_ConnString_ToSave != "") {
      azureStorage = XAzureStorage.parse(blob_ConnString_ToSave ?? "");
    }
    loadPlatform();
    loadPath();
    XColors.done = Color.fromARGB(255, 36, 136, 39);
    XUtils.widthMin_Layout = 800;
    XfxMenu.menuItem_WidthDefault = 300;
  }

  loadPath() async {
    var p = Directory('/storage/emulated/0/Download/${app_Name.replaceAll(" ", "")}'); //await getExternalStorageDirectories(type: StorageDirectory.downloads);
    if (p.existsSync()) {
      XLibStorage.filePath = p.path;
    } else {
      final Directory _appDirNewFolder = await p.create(recursive: true);
      XLibStorage.filePath = _appDirNewFolder.path;
    }
  }

  loadPlatform() async {
    packageInfo = packageInfo = await PackageInfo.fromPlatform();
  }
}

class DataService {}

class XAppServices {}

class XAppData {}
